// Copyright (c) 2008, NTT DATA Corporation.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using TERASOLUNA.Fw.Web;
using TERASOLUNA.Fw.Web.HttpModule;
using TERASOLUNA.Fw.Utlib.Logging;
using TERASOLUNA.Fw.Common.Logging;

namespace TERASOLUNA.Fw.WebUT.HttpModules
{
    /// <summary>
    /// TERASOLUNA.Fw.Web.TokenProcessorImpl のテスト クラスです。すべての
    /// TERASOLUNA.Fw.Web.TokenProcessorImpl 単体テストをここに含めます
    /// </summary>

    [TestClass()]
    public class TokenProcessorImplTest
    {

        private TestContext testContextInstance;

        /// <summary>
        ///現在のテストの実行についての情報および機能を
        ///提供するテスト コンテキストを取得または設定します。
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region 追加のテスト属性
        // 
        //テストを作成するときに、次の追加属性を使用することができます:
        //
        //クラスの最初のテストを実行する前にコードを実行するには、ClassInitialize を使用
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //クラスのすべてのテストを実行した後にコードを実行するには、ClassCleanup を使用
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //各テストを実行する前にコードを実行するには、TestInitialize を使用
        [TestInitialize()]
        public void MyTestInitialize()
        {
            LogUTUtil.Clear();
        }
        //
        //各テストを実行した後にコードを実行するには、TestCleanup を使用
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        /// CreateNewToken (string) のテスト
        /// </summary>
        /// <TestTarget>CreateNewToken (string)</TestTarget>
        /// <TestCondition>引数にnullを指定すること</TestCondition>
        /// <TestAssertion>引数と異なる値が返却されること</TestAssertion>
        [TestMethod()]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal01.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal02.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_PageExternalExTran.config")]
        public void TestCreateNewToken01()
        {
            TokenProcessorImpl target = new TokenProcessorImpl();

            //TERASOLUNA_Fw_Web_TokenProcessorImplAccessor accessor = new TERASOLUNA_Fw_Web_TokenProcessorImplAccessor(target);

            string oldToken = null;
            string actual;

            // 繰り返し実行して、異なるトークンが生成されることを確認する。
            for (int i = 0; i < 10000; i++)
            {
                actual = TERASOLUNA_Fw_Web_HttpModule_TokenProcessorImplAccessor.CreateNewToken(oldToken);

                Assert.AreNotEqual(oldToken, actual);

                oldToken = actual;

                // ログの確認
                Assert.AreEqual(0, LogUTUtil.CountLogs(typeof(TokenProcessorImpl), LogLevel.INFO));
            }
        }
        /// <summary>
        /// CreateNewToken (string) のテスト
        /// </summary>
        /// <TestTarget>CreateNewToken (string)</TestTarget>
        /// <TestCondition>引数に"test"を指定すること</TestCondition>
        /// <TestAssertion>引数と異なる値が返却されること</TestAssertion>
        [TestMethod()]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal01.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal02.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_PageExternalExTran.config")]
        public void TestCreateNewToken02()
        {
            TokenProcessorImpl target = new TokenProcessorImpl();

            //TERASOLUNA_Fw_Web_TokenProcessorImplAccessor accessor = new TERASOLUNA_Fw_Web_TokenProcessorImplAccessor(target);

            string oldToken = "test";
            string actual;

            // 繰り返し実行して、異なるトークンが生成されることを確認する。
            for (int i = 0; i < 10000; i++)
            {
                actual = TERASOLUNA_Fw_Web_HttpModule_TokenProcessorImplAccessor.CreateNewToken(oldToken);

                Assert.AreNotEqual(oldToken, actual);

                oldToken = actual;
            }

            // ログの確認
            Assert.AreEqual(0, LogUTUtil.CountLogs(typeof(TokenProcessorImpl), LogLevel.INFO));
        }
        /// <summary>
        /// CreateNewToken (string) のテスト
        /// </summary>
        /// <TestTarget>CreateNewToken (string)</TestTarget>
        /// <TestCondition>引数に空文字を指定すること</TestCondition>
        /// <TestAssertion>引数と異なる値が返却されること</TestAssertion>
        [TestMethod()]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal01.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_ExceptionTransitionExternal02.config")]
        [DeploymentItem(@"Configuration\ExceptionTransition\TestItem_PageExternalExTran.config")]
        public void TestCreateNewToken03()
        {
            TokenProcessorImpl target = new TokenProcessorImpl();

            string oldToken = "";
            string actual;

            // 繰り返し実行して、異なるトークンが生成されることを確認する。
            for (int i = 0; i < 10000; i++)
            {
                actual = TERASOLUNA_Fw_Web_HttpModule_TokenProcessorImplAccessor.CreateNewToken(oldToken);

                Assert.AreNotEqual(oldToken, actual);

                oldToken = actual;
            }

            // ログの確認
            Assert.AreEqual(0, LogUTUtil.CountLogs(typeof(TokenProcessorImpl), LogLevel.INFO));
        }
    }
}
